from cmk.gui.i18n import _
from cmk.gui.plugins.wato import (
    CheckParameterRulespecWithoutItem,
    rulespec_registry,
    RulespecGroupCheckParametersApplications
)

from cmk.gui.valuespec import (
    Dictionary,
    ListChoice,
    Tuple,
    Percentage,
    Integer,
    Float,
)

def _parameter_spec_mailcow_info():
    return Dictionary(
        elements=[
            ("levels_num_domains", Tuple(
                title=_("Number of email domains"),
                    elements=[
                        Integer(
                            title=_("Warning at"),
                            default_value=100,
                        ),
                        Integer(
                            title=_("Critical at"),
                            default_value=200,
                        )
                    ],
            )),
            ("levels_num_mailboxes", Tuple(
                title=_("Number of mailboxes"),
                    elements=[
                        Integer(
                            title=_("Warning at"),
                            default_value=500,
                        ),
                        Integer(
                            title=_("Critical at"),
                            default_value=1000,
                        )
                    ],
            )),
            ("levels_num_global_messages", Tuple(
                title=_("Number of messages"),
                    elements=[
                        Integer(
                            title=_("Warning at"),
                            default_value=100000,
                        ),
                        Integer(
                            title=_("Critical at"),
                            default_value=250000,
                        )
                    ],
            )),
        ],
    )

rulespec_registry.register(
    CheckParameterRulespecWithoutItem(
        check_group_name="mailcow_info",
        group=RulespecGroupCheckParametersApplications,
        match_type="dict",
        parameter_valuespec=_parameter_spec_mailcow_info,
        title=lambda: _("Mailcow Info"),
    )
)